unit u_saut_test1;

interface
  uses
    SysUtils,
    Math,
    Dialogs;
    const
      MAX = 500;
      MAX_ob = 50;
      coeff = 0.7;
      v0 = 8;

   Type Vecteur=Record

                  X,Y :Real ;

             End;
        t_tab = array[1..MAX,1..2] of real;
        t_obst = array[1..MAX_ob, 1..2] of real;



  const g:Vecteur=(X:0;Y:-9.8);

      dt:Real=0.03;  // ecart de temp entre deux iterations

      angle : Real= PI/2;

 function saut_test1(var tab : t_tab; v0, sol : real) : t_tab;
 function VX(coef, v0 : real) : real;
 function VY(coef, v0 : real) : real;
 function saut(tab : t_tab; v0, sol : real) : t_tab;
 function obstacle_crea (var tab : t_obst; x1, x2, y1, y2 : real) : t_obst;
 function obstacle_verif (var tab : t_obst; x, y, larg : real) : boolean;



implementation




var

  P : Vecteur;
  t : Real;

function saut_test1(var tab : t_tab; v0, sol : real) : t_tab;
  // saut_test1(tableau vide; vitesse init) : tableau de position a 2D (x, y)
  var
    li, col : integer;
begin
  t := 0;
  P.Y := sol;
  li := 1;
  col := 1;
  while P.Y >= sol do
    begin
      P.X := VX(coeff, v0)*t;

      P.Y := VY(coeff, v0)*t+g.Y*t*t/2 + sol;

      t:=t+dt;              // change temp

      tab[li, col] := P.X;
      tab[li, col+1] := P.Y;
      li := li+1;
    end;
    Result := tab;
end;


function VX(coef, v0 : real) : real;
  begin
    Result := v0*Cos(angle)*coef;
  end;

function VY(coef, v0 : real) : real;
  begin
     Result := v0*Sin(angle)*coef;
  end;

function saut(tab : t_tab; v0, sol : real) : t_tab;
  var
    arr : t_tab;
    i : integer;
  begin
    for i := 1 to MAX do
      begin
          arr[i, 1] := sol;
          arr[i, 2] := sol;
      end;
      i := 1;
      while saut_test1(tab, v0, sol)[i, 2] >= sol do
          begin
              arr[i, 1] := saut_test1(tab, v0, sol)[i, 1];
              arr[i, 2] := saut_test1(tab, v0, sol)[i, 2];
              i := i+1;
          end;
      Result := arr;
  end;


  function obstacle_crea (var tab : t_obst; x1, x2, y1, y2 : real) : t_obst;
    // cree un tableau ou sont mis toutes les coordonnes des obstacles
    Var
      i : integer;
      b : boolean;
    begin
        i := 1;
        b := TRUE;
        while ( i <= MAX_ob ) AND b do
          begin
            if tab[i, 1] = 42 then
              begin
               tab[i, 1] := x1;
               tab[i, 2] := x2;
               tab[i+1, 1] := y1;
               tab[i+1, 2] := y2;
               b := FALSE;
              end
            else
              i := i+1;

          end;
        Result := tab;
    end;

  function obstacle_verif (var tab : t_obst; x, y, larg : real) : boolean;
    // verif si le pt (x, y) est dans l'obstacle definis dans le tableau 'tab'
    // cre dans la fonction obstacle_crea
    Var
      i : integer;
      b_boucle, b_retour : boolean;
    begin
        i := 1;
        b_boucle := TRUE;
        b_retour := FALSE;
        while ( i <= MAX_ob ) AND b_boucle do
          begin
              if tab[i, 1] = 42 then
                b_boucle := FALSE
              else
                if ((( y+larg >= tab[i+1,1] ) AND ( y+larg <= tab[i+1, 2] ))
                    OR (( y >= tab[i+1,1] ) AND ( y <= tab[i+1, 2] )))
                    AND (( x >= tab[i, 1] ) AND ( x <= tab[i, 2]+larg )) then
                  begin
                    b_boucle := FALSE;
                    b_retour := TRUE;
                  end;
                i := i+2;
          end;
        Result := b_retour;
    end;
end.
